//+------------------------------------------------------------------+
//|                                             Awaiter Template.mq4 |
//|                                Copyright 2021, Centropolis Corp. |
//|                                           https://centropolis.tk |
//+------------------------------------------------------------------+
#property copyright "Copyright 2021, Centropolis Corp."
#property link      "https://centropolis.tk"
#property version   "1.00"
#property strict

///.............автоматически генерируемые значения...........
bool bAntiSpreadNoize = true;//использовать режим подавления спредовых шумов
double C1[] = { 1,0.729902909477196,0.201981212658762,0.180705771805135,0.131598867837263,0.0575991302125474,0.0229680525674959,0.00511072854088536,0.00270930750339156,0.001890858079472,0.00168827275547086,0.00083155495456859,0.000219153167059367,0.000102718901079113,3.53508113008356E-05,6.93382104586297E-06,3.99781351967122E-06,2.41644968418629E-06,4.81643847329394E-07 };//массив для коэффициентов
int CNum=91;//количество свечей в формуле
int DeepBruteX=6;//глубина формулы
string Method="PHYSICS";//метод
int DatetimeStart=1639964700;//стартовая точка времени
bool bInvert=false;//Trade Invert
extern int DaysToFuture=3000;//Days To Future
bool bCloseInOutOfTime=false;//Close Out Of Time
int DaysToTrade[]={ 2,4,5 };//Days To Trade
///...........................................................


double LastLow;
double LastHigh;

int Spread=10000000;
int HighSpread=10000000;
int LowSpread=10000000;

int PrevSpread=10000000;
int PrevHighSpread=10000000;
int PrevLowSpread=10000000;


enum LOT_VARIATION
   {
   SIMPLE_LOT,
   VARIATION_LOCAL_INCREASE,
   VARIATION_LOCAL_DECREASE,
   MARTINGALE
   };


extern LOT_VARIATION LotMode=SIMPLE_LOT;//Lot Mode
bool bPrintValue=false;//Signal To Log

///крутим ручками
double ValueOpenEMax=1000000.0;//Max Open Signal  
double ValueOpenE=92.9843753851826;//Open Signal
bool bUseTimeCorridorE=true;//Use Time Corridor
int TradeHour=21;//Start Trading Hour
int TradeMinute=3;//Start Trading Minute
int TradeHourEnd=0;//End Trading Hour
int TradeMinuteEnd=50;//End Trading Minute
double ValueCloseE=0.001;//Close Signal

extern double MinLotE=0.01;//Min Lot
extern double Lot=0.1;//Lot (Fix Lot & Optimal Lot Start Value)
extern double MaxLotE=1.0;//Max Lot
extern double LotMultiplierE=2.0;//Martin Lot Multiplier


///////параметры торговли
extern bool bBuyInit=true;//Buy Trades
extern bool bSellInit=true;//Sell Trades
extern bool TradeJustWhenNoOrders=true;//Just One Order In Terminal
extern int SlippageMaxOpen=15;//Slippage Open
extern int SlippageMaxClose=100;//Slippage Close

extern int SLE=3000;//Stop Loss
extern int TPE=3000;//Take Profit

extern bool bInitLotControl=false;//Auto Lot
extern double DEPOSITTOMINLOTE=100.0;//Deposit For Lot
////////переменные для спреда
bool bInitSpreadControl=true;//Spread Control
int SpreadE=100;//Spread Max
int SpreadCloseE=100;//Spread For Close Max
extern int MagicF=15670867;//Magic
////

string CurrentSymbol=Symbol();


int HourCorrect(int hour0)
   {
   int rez=0;
   if ( hour0 < 24 && hour0 > 0 )
      {
      rez=hour0;
      }
   return rez;
   }
   
int MinuteCorrect(int minute0)
   {
   int rez=0;
   if ( minute0 < 60 && minute0 > 0 )
      {
      rez=minute0;
      }
   return rez;      
   }

bool bDay()
   {
   for ( int i=0; i<ArraySize(DaysToTrade); i++ )
      {
      if ( TimeDayOfWeek(Time[0]) == DaysToTrade[i] ) return true;
      }
   return false;
   }

void Trade()
   {
   double Value;
   Value=PolinomTrade();
   int MinuteEquivalent=TimeHour(Time[0])*60+TimeMinute(Time[0]);
   int BorderMinuteStartTrade=HourCorrect(TradeHour)*60+MinuteCorrect(TradeMinute);
   int BorderMinuteEndTrade=HourCorrect(TradeHourEnd)*60+MinuteCorrect(TradeMinuteEnd);

   if ( bUseTimeCorridorE && bCloseInOutOfTime && BorderMinuteStartTrade > BorderMinuteEndTrade )
      {
      if ( MinuteEquivalent>=BorderMinuteEndTrade && MinuteEquivalent<= BorderMinuteStartTrade )
         {
         CloseType(OP_BUY,MagicF);
         CloseType(OP_SELL,MagicF);
         }        
      }
   if ( bUseTimeCorridorE && bCloseInOutOfTime && BorderMinuteStartTrade <= BorderMinuteEndTrade )
      {
      if ( !(MinuteEquivalent>=BorderMinuteStartTrade && MinuteEquivalent<= BorderMinuteEndTrade) )
         {
         CloseType(OP_BUY,MagicF);
         CloseType(OP_SELL,MagicF);
         }        
      }

   if ( Value > ValueCloseE)
      {
      if ( !bInvert ) 
         {
         CloseType(OP_BUY,MagicF);
         }      
      else 
         {
         CloseType(OP_SELL,MagicF);
         }
      }
      
   if ( Value < -ValueCloseE)
      {
      if ( !bInvert )
         {
         CloseType(OP_SELL,MagicF);
         }      
      else 
         {
         CloseType(OP_BUY,MagicF);
         }      
      }

   if ( !bUseTimeCorridorE )
      {
      if ( Days() <= DaysToFuture && Value > ValueOpenE && Value <= ValueOpenEMax )
         {
         if ( !bInvert ) SellF(SLE,TPE,Lot);
         else BuyF(SLE,TPE,Lot);
         }
      
      if ( Days() <= DaysToFuture && Value < -ValueOpenE && Value >= -ValueOpenEMax )
         {
         if ( !bInvert ) BuyF(SLE,TPE,Lot);
         else SellF(SLE,TPE,Lot);
         }      
      }
   else
      {
      if ( BorderMinuteStartTrade > BorderMinuteEndTrade && bDay() )
         {
         if ( !(MinuteEquivalent>=BorderMinuteEndTrade && MinuteEquivalent<= BorderMinuteStartTrade) )
            {
            if ( Days() <= DaysToFuture && Value > ValueOpenE && Value <= ValueOpenEMax )
               {
               if ( !bInvert ) SellF(SLE,TPE,Lot);
               else BuyF(SLE,TPE,Lot);
               }
      
            if ( Days() <= DaysToFuture && Value < -ValueOpenE && Value >= -ValueOpenEMax )
               {
               if ( !bInvert ) BuyF(SLE,TPE,Lot);
               else SellF(SLE,TPE,Lot);
               }
            }        
         }
      if ( BorderMinuteStartTrade <= BorderMinuteEndTrade && bDay() )
         {
         if ( MinuteEquivalent>=BorderMinuteStartTrade && MinuteEquivalent<= BorderMinuteEndTrade )
            {
            if ( Days() <= DaysToFuture && Value > ValueOpenE && Value <= ValueOpenEMax )
               {
               if ( !bInvert ) SellF(SLE,TPE,Lot);
               else BuyF(SLE,TPE,Lot);
               }
      
            if ( Days() <= DaysToFuture && Value < -ValueOpenE && Value >= -ValueOpenEMax )
               {
               if ( !bInvert ) BuyF(SLE,TPE,Lot);
               else SellF(SLE,TPE,Lot);
               }
            }        
         }      
      }
   
   if ( bPrintValue ) Print("Value="+DoubleToString(Value));
   }
   
  
double Val;
int iterator;
double PolinomTrade()//полином для торговли
   {
   Val=0;
   iterator=0;

   if (Method == "PHYSICS")//новый метод на простейшей физике открытия и закрытия
   {
       for (int i = 0; i < CNum; i++)
       {
           double Ct = 0;
           iterator = 0;
           Ct += C1[iterator];
           iterator++;
           for (int j = 0; j < DeepBruteX ; j++)//от глубины зависит количество слагаемых
           {
               if (C1[iterator + 1] != 0) Ct += C1[iterator+2] * MathPow(double(i + 1), C1[iterator] / C1[iterator + 1]);
               else Ct = 100000000.0;
               iterator +=3;
           }

           if ( Ct != 0.0  ) Val +=  ( (Close[i+1]-Open[i+1]) / Point ) / Ct;
       }
       return Val;
   }    

   if ( Method == "TEYLOR" )
      {
      if ( DeepBruteX <= 1 )
         {
		 for ( int i=0; i<CNum; i++ )
		   {
		   Val+=C1[iterator]*(Close[i+1]-Open[i+1])/Point;
		   iterator++;
		   }

		 for ( int i=0; i<CNum; i++ )
		   {
		   Val+=C1[iterator]*(High[i+1]-Open[i+1])/Point;
		   iterator++;
		   }

		 for ( int i=0; i<CNum; i++ )
		   {
		   Val+=C1[iterator]*(Open[i+1]-Low[i+1])/Point;
		   iterator++;
		   }

		 for ( int i=0; i<CNum; i++ )
		   {
		   Val+=C1[iterator]*(High[i+1]-Close[i+1])/Point;
		   iterator++;
		   }

		 for ( int i=0; i<CNum; i++ )
		   {
		   Val+=C1[iterator]*(Close[i+1]-Low[i+1])/Point;
		   iterator++;
		   }            

         return Val;   
         }
      else
         {
         CalcDeep(C1,CNum,DeepBruteX);
         return ValStart;
         }      
      }
   if ( Method == "FOURIER" )
      {
	  for ( int i=0; i<CNum; i++ )
		{
		Val+=C1[iterator]*MathSin(C1[iterator+1]*(Close[i+1]-Open[i+1])/Point)+C1[iterator+2]*MathCos(C1[iterator+3]*(Close[i+1]-Open[i+1])/Point);
		iterator+=4;
		}

	  for ( int i=0; i<CNum; i++ )
		{
		Val+=C1[iterator]*MathSin(C1[iterator+1]*(High[i+1]-Open[i+1])/Point)+C1[iterator+2]*MathCos(C1[iterator+3]*(High[i+1]-Open[i+1])/Point);
		iterator+=4;
		}

	  for ( int i=0; i<CNum; i++ )
		{
		Val+=C1[iterator]*MathSin(C1[iterator+1]*(Open[i+1]-Low[i+1])/Point)+C1[iterator+2]*MathCos(C1[iterator+3]*(Open[i+1]-Low[i+1])/Point);
		iterator+=4;
		}

	  for ( int i=0; i<CNum; i++ )
		{
		Val+=C1[iterator]*MathSin(C1[iterator+1]*(High[i+1]-Close[i+1])/Point)+C1[iterator+2]*MathCos(C1[iterator+3]*(High[i+1]-Close[i+1])/Point);
		iterator+=4;
		}

	  for ( int i=0; i<CNum; i++ )
		{
		Val+=C1[iterator]*MathSin(C1[iterator+1]*(Close[i+1]-Low[i+1])/Point)+C1[iterator+2]*MathCos(C1[iterator+3]*(Close[i+1]-Low[i+1])/Point);
		iterator+=4;
		}         

      return Val;
      }
   return 0.0;      
   }


///фрактальный подсчет чисел
double ValW;//число куда умножаем все(а потом его прибавляем к ValStart)
uint NumC;//текущее число для коэффициента
double ValStart;//число куда суммируем все
void Deep(double &Ci0[],int Nums,int deepC,int deepStart,double Val0=1.0)//промежуточный фрактал
   {
   for ( int i=0; i<Nums; i++ )
	 {
	 if (deepC > 1)
		{
		ValW=(Close[i+1]-Open[i+1])*Val0;
		Deep(Ci0,Nums,deepC-1,deepStart,ValW);
		} 
	 else 
		{
		ValStart+=Ci0[NumC]*(Close[i+1]-Open[i+1])*Val0/Point;
		NumC++;
		}
	 } 
  
   for ( int i=0; i<Nums; i++ )
	 {
	 if (deepC > 1)
		{
		ValW=(High[i+1]-Open[i+1])*Val0;
		Deep(Ci0,Nums,deepC-1,deepStart,ValW);
		} 
	 else 
		{
		ValStart+=Ci0[NumC]*(High[i+1]-Open[i+1])*Val0/Point;
		NumC++;
		}
	 }

   for ( int i=0; i<Nums; i++ )
	 {
	 if (deepC > 1)
		{
		ValW=(Open[i+1]-Low[i+1])*Val0;
		Deep(Ci0,Nums,deepC-1,deepStart,ValW);
		} 
	 else 
		{
		ValStart+=Ci0[NumC]*(Open[i+1]-Low[i+1])*Val0/Point;
		NumC++;
		}
	 }

   for ( int i=0; i<Nums; i++ )
	 {
	 if (deepC > 1)
		{
		ValW=(High[i+1]-Close[i+1])*Val0;
		Deep(Ci0,Nums,deepC-1,deepStart,ValW);
		} 
	 else 
		{
		ValStart+=Ci0[NumC]*(High[i+1]-Close[i+1])*Val0/Point;
		NumC++;
		}
	 }

   for ( int i=0; i<Nums; i++ )
	 {
	 if (deepC > 1)
		{
		ValW=(Close[i+1]-Low[i+1])*Val0;
		Deep(Ci0,Nums,deepC-1,deepStart,ValW);
		} 
	 else 
		{
		ValStart+=Ci0[NumC]*(Close[i+1]-Low[i+1])*Val0/Point;
		NumC++;
		}
	 }      
   }
   
void CalcDeep(double &Ci0[],int Nums,int deepC=1)
   {
   NumC=0;
   ValStart=0.0;
   for ( int i=0; i<deepC; i++ )
      {
      Deep(Ci0,Nums,i+1,i+1);
      }   
   }
///
///фрактальный подсчет числа коэффициентов
int NumCAll=0;//размер массива коэффициентов
void DeepN(int Nums,int deepC=1)//промежуточный фрактал
   {
   for ( int i=0; i<Nums*5; i++ )
      {
      if (deepC > 1) DeepN(Nums,deepC-1);
      else NumCAll++;
      }
   }

void CalcDeepN(int Nums,int deepC=1)
   {
   NumCAll=0;
   for ( int i=0; i<deepC; i++ ) DeepN(Nums,i+1);
   }
///


/////////********/////////********//////////***********/////////блок кода функций торговли
void BuyF(double SL0,double TP0,double Lot0)
   {
   bool ord;
   int OrdersG0=0;
   double DtA;
   double SLTemp0=MathAbs(SL0);
   double TPTemp0=MathAbs(TP0);   
   double Mt=Lot0; 
      for ( int i=0; i<OrdersTotal(); i++ )
         {
         ord=OrderSelect( i, SELECT_BY_POS, MODE_TRADES );
         if ( OrderSymbol() == CurrentSymbol &&  OrderMagicNumber() == MagicF )
            {
            OrdersG0++;
            }
         }
      
      
      
   DtA=double(TimeCurrent())-GlobalVariableGet("TimeStart161");
   if ( ( (TradeJustWhenNoOrders == false && OrdersG0 == 0) || (TradeJustWhenNoOrders == true && OrdersTotal() == 0) ) && (DtA > 0 || DtA < 0) )
      {
      CheckForOpen(bBuyInit,MagicF,OP_BUY,Bid,Ask,MathAbs(SlippageMaxOpen),Bid,int(SLTemp0),int(TPTemp0),MathAbs(Mt),CurrentSymbol,0,NULL,bInitLotControl,bInitSpreadControl,SpreadE);
      }
   }
   
void SellF(double SL0,double TP0,double Lot0)
   {
   bool ord;
   int OrdersG0=0;
   double DtA;
   double SLTemp0=MathAbs(SL0);
   double TPTemp0=MathAbs(TP0);   
   double Mt=Lot0;     
      for ( int i=0; i<OrdersTotal(); i++ )
         {
         ord=OrderSelect( i, SELECT_BY_POS, MODE_TRADES );
         if ( OrderSymbol() == CurrentSymbol &&  OrderMagicNumber() == MagicF )
            {
            OrdersG0++;
            }
         }
         
   DtA=double(TimeCurrent())-GlobalVariableGet("TimeStart161");
   if ( ( (TradeJustWhenNoOrders == false && OrdersG0 == 0) || (TradeJustWhenNoOrders == true && OrdersTotal() == 0) ) && (DtA > 0 || DtA < 0) )
      {
      CheckForOpen(bSellInit,MagicF,OP_SELL,Bid,Ask,MathAbs(SlippageMaxOpen),Bid,int(SLTemp0),int(TPTemp0),MathAbs(Mt),CurrentSymbol,0,NULL,bInitLotControl,bInitSpreadControl,SpreadE);
      }
   }

   
double Days()
   {
   if ( double(Time[0] - DatetimeStart) > 0 ) return double(Time[0] - DatetimeStart)/86400.0;
   else return 0.0;     
   }
  

double CalcMultiplierLinearIncrease()//посчитаем следующий лот увеличения для локальных участков
   {
   double EquivalentTime=Days()*86400.0;
   double LotFT=(EquivalentTime/double(DaysToFuture*86400.0))*double(MaxLotE-MinLotE) + MinLotE;
   if ( EquivalentTime <= 0.0 ) return MinLotE;
   else return LotFT;
   }
   
double CalcMultiplierLinearDecrease()//посчитаем следующий лот уменьшения для локальных участков
   {
   double EquivalentTime=Days()*86400.0;
   Print(Days());
   double LotFT=MaxLotE-(EquivalentTime/double(DaysToFuture*86400.0))*double(MaxLotE-MinLotE);
   if ( EquivalentTime <= 0.0 ) return MaxLotE;
   else return LotFT;
   }

void CheckForOpen(bool Condition0,int Magic0,int OrdType,double PriceBid,double PriceAsk,int Slippage0,double PriceClose0,int SL0,int TP0,double Lot0,string Symbol0,datetime Expiration0,string Comment0,bool bLotControl0,bool bSpreadControl0,int Spread0)
   {
   bool ord;                          //открытие ордера при условии Condition0
   double LotTemp=Lot0;
   double SpreadLocal=MarketInfo(CurrentSymbol,MODE_SPREAD);
   double LotAntiError=MarketInfo(CurrentSymbol,MODE_MINLOT);
                                                       
   if ( Condition0 == true && ( (SpreadLocal <= Spread0 && bSpreadControl0 == true ) || ( bSpreadControl0 == false ) )  )                    
      {   
      if ( bLotControl0 == false && LotMode == SIMPLE_LOT )
         {
         LotTemp=Lot0;
         }
      if ( bLotControl0 == true && LotMode == SIMPLE_LOT )
         {
         if ( DEPOSITTOMINLOTE > 0.0 ) LotTemp=Lot0*(AccountBalance()/DEPOSITTOMINLOTE);
         else LotTemp=Lot0;
         }
         
      if ( LotMode == VARIATION_LOCAL_INCREASE )
         {
         LotTemp=CalcMultiplierLinearIncrease();
         }
      if ( LotMode == VARIATION_LOCAL_DECREASE )
         {
         LotTemp=CalcMultiplierLinearDecrease();
         }
      if ( LotMode == MARTINGALE )
         {
         LotTemp=CalcMartinLot(LotTemp);
         }          

      LotAntiError=GetLotAniError(LotTemp);
      if ( LotAntiError <= 0 )
         {
         Print("TOO Low  Free Margin Level !");
         }

      if ( LotAntiError > 0 &&  (OrdType == OP_SELL || OrdType == OP_SELLLIMIT || OrdType == OP_SELLSTOP) )
         {
         GlobalVariableSet("TimeStart161",double(TimeCurrent()) );
         ord=OrderSend( Symbol0 , OrdType, LotAntiError, PriceBid, Slippage0, PriceClose0 + CorrectLevels(SL0)*Point, PriceClose0 - CorrectLevels(TP0)*Point, Comment0, Magic0, Expiration0, Red);
         }
      if ( LotAntiError > 0 &&  (OrdType == OP_BUY || OrdType == OP_BUYLIMIT || OrdType == OP_BUYSTOP) )
         {
         GlobalVariableSet("TimeStart161",double(TimeCurrent()) );
         ord=OrderSend( Symbol0 , OrdType, LotAntiError, PriceAsk, Slippage0, PriceClose0 - CorrectLevels(SL0)*Point, PriceClose0 + CorrectLevels(TP0)*Point, Comment0, Magic0, Expiration0, Green);
         }                     
      }
      
   }

double GetLotAniError(double InputLot)
   {
   double Free = AccountFreeMargin();
   double margin = MarketInfo(CurrentSymbol,MODE_MARGINREQUIRED);
   double minLot = MarketInfo(CurrentSymbol,MODE_MINLOT);
   double Max_Lot = MarketInfo(CurrentSymbol,MODE_MAXLOT);
   double Step = MarketInfo(CurrentSymbol,MODE_LOTSTEP);
   double Lot13;
   int LotCorrection;
   LotCorrection=int(MathFloor(InputLot/Step));
   Lot13=LotCorrection*Step;   
   if(Lot13<=minLot) Lot13 = minLot;
   if(Lot13>=Max_Lot) Lot13 = Max_Lot;
   
   if( Lot13*margin>=Free ) Lot13=-1.0;

   return Lot13;
   }

 
bool bTimeInterval(int HourStart0,int MinuteStart0,int HourEnd0,int MinuteEnd0,bool bInitPCTime0)
   {
   bool rez=false;
   
   if ( (Hour() >= HourStart0 && Hour() <= HourEnd0 && Minute() >= MinuteStart0 && Minute() <= MinuteEnd0 && bInitPCTime0==false) || ( TimeHour(TimeLocal()) >= HourStart0 && TimeHour(TimeLocal()) <= HourEnd0 && TimeMinute(TimeLocal()) >= MinuteStart0 && TimeMinute(TimeLocal()) <= MinuteEnd0 && bInitPCTime0==true) )
      {
      rez=true;
      }
      
   return rez;
   } 

int CorrectLevels(int level0)
   {
   int rez;
   int ZeroLevel0=int(MathAbs(MarketInfo(CurrentSymbol,MODE_STOPLEVEL))+MathAbs(MarketInfo(CurrentSymbol,MODE_SPREAD))+MathAbs(SlippageMaxOpen)+1);

   if ( MathAbs(level0) > ZeroLevel0 )
      {
      rez=int(MathAbs(level0));
      }
   else
      {
      rez=ZeroLevel0;
      }   
   return rez;
   }
   
void CloseAll(int magic0)//закрыть все
   {
   bool order;
   bool ord;
   int Tickets[];
   double Lotsx[];
   bool Typex[];      
   string SymbolX[];   
   int TicketsTotal=0;
   int TicketNumCurrent=0;
   MqlTick TickS;
   
   if ( !bInitSpreadControl || (bInitSpreadControl && MarketInfo(Symbol(),MODE_SPREAD) <= SpreadCloseE) )
      {
      for ( int i=0; i<OrdersTotal(); i++ )
         {
         ord=OrderSelect( i, SELECT_BY_POS, MODE_TRADES );
                            
         if ( OrderMagicNumber() == magic0 )
            {
            TicketsTotal=TicketsTotal+1;
            }
         }
      ArrayResize(Tickets,TicketsTotal);
      ArrayResize(Lotsx,TicketsTotal);
      ArrayResize(Typex,TicketsTotal);
      ArrayResize(SymbolX,TicketsTotal);
            
      for ( int i=0; i<OrdersTotal(); i++ )
         {
         ord=OrderSelect( i, SELECT_BY_POS, MODE_TRADES );
                            
         if (  OrderMagicNumber() == magic0 && TicketNumCurrent < TicketsTotal )
            {
            Tickets[TicketNumCurrent]=OrderTicket();
            if ( OrderType() == OP_BUY )
               {
               Typex[TicketNumCurrent]=true;
               }
            if ( OrderType() == OP_SELL )
               {
               Typex[TicketNumCurrent]=false;
               }                           
            Lotsx[TicketNumCurrent]=OrderLots();
            SymbolX[TicketNumCurrent]=OrderSymbol();            
            TicketNumCurrent=TicketNumCurrent+1;
            }
         }
         
      for ( int i=0; i<TicketsTotal; i++ )
         {
         SymbolInfoTick(SymbolX[i],TickS);
         if ( Typex[i] == true )
            {
            order=OrderClose(Tickets[i],Lotsx[i],TickS.bid,MathAbs(SlippageMaxClose),Green);
            }
         if ( Typex[i] == false )
            {
            order=OrderClose(Tickets[i],Lotsx[i],TickS.ask,MathAbs(SlippageMaxClose),Red);
            }       
         }                     
      }
   
   }  

void CloseType(ENUM_ORDER_TYPE OT,int magic0)//закрыть все ордера указанного типа
   {
   bool order;
   bool ord;
   int Tickets[];
   double Lotsx[];
   bool Typex[];      
   string SymbolX[];   
   int TicketsTotal=0;
   int TicketNumCurrent=0;
   MqlTick TickS;
   
   if (  !bInitSpreadControl || (bInitSpreadControl && MarketInfo(Symbol(),MODE_SPREAD) <= SpreadCloseE)  )
      {
      for ( int i=0; i<OrdersTotal(); i++ )
         {
         ord=OrderSelect( i, SELECT_BY_POS, MODE_TRADES );
                            
         if ( OrderMagicNumber() == magic0 )
            {
            TicketsTotal=TicketsTotal+1;
            }
         }
      ArrayResize(Tickets,TicketsTotal);
      ArrayResize(Lotsx,TicketsTotal);
      ArrayResize(Typex,TicketsTotal);
      ArrayResize(SymbolX,TicketsTotal);
            
      for ( int i=0; i<OrdersTotal(); i++ )
         {
         ord=OrderSelect( i, SELECT_BY_POS, MODE_TRADES );
                            
         if (  OrderMagicNumber() == magic0 && TicketNumCurrent < TicketsTotal )
            {
            Tickets[TicketNumCurrent]=OrderTicket();
            if ( OrderType() == OP_BUY )
               {
               Typex[TicketNumCurrent]=true;
               }
            if ( OrderType() == OP_SELL )
               {
               Typex[TicketNumCurrent]=false;
               }                           
            Lotsx[TicketNumCurrent]=OrderLots();
            SymbolX[TicketNumCurrent]=OrderSymbol();            
            TicketNumCurrent=TicketNumCurrent+1;
            }
         }
         
      for ( int i=0; i<TicketsTotal; i++ )
         {
         SymbolInfoTick(SymbolX[i],TickS);
         if ( Typex[i] == true && OT == OP_BUY )
            {
            order=OrderClose(Tickets[i],Lotsx[i],TickS.bid,MathAbs(SlippageMaxClose),Green);
            }
         if ( Typex[i] == false && OT == OP_SELL )
            {
            order=OrderClose(Tickets[i],Lotsx[i],TickS.ask,MathAbs(SlippageMaxClose),Red);
            }       
         }                     
      }
   
   }    
/////////////////////////////////










//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
  CreateSimpleInterface();
  UpdateStatus();
  return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
  DeleteSimpleInterface();
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+

datetime Time0;

bool bNewBar()
   {
   if ( Time0 < Time[0] )
      {
      if (Time0 != 0)
         {
         Time0=Time[0];
         PrevSpread=Spread;
         PrevHighSpread=HighSpread;
         PrevLowSpread=LowSpread;
         Spread=int(MarketInfo(Symbol(),MODE_SPREAD));
         HighSpread=Spread;
         LowSpread=Spread;
         
         LastHigh=Close[0];
         LastLow=Close[0];
         
         return true;
         }
      else
         {
         Time0=Time[0];
         return false;
         }
      }
   else return false;
   }

void OnTick()
  {
  if ( bNewBar())
     {
     Trade();
     if ( Days() > DaysToFuture )
        {
        CloseType(OP_SELL,MagicF);   
        CloseType(OP_BUY,MagicF);
        Print("the time of the projected work has come to an end, shutdown...");
        ExpertRemove();
        }
     }
  UpdateStatus();  
  }

 ///
 double CalcMartinLot(double BasicLot)//вычисление лота для мартина
   {
   bool ord;
   double TotalLot=0;
   for ( int i=OrdersHistoryTotal()-1; i>=0; i-- )
      {
      ord=OrderSelect(i, SELECT_BY_POS,MODE_HISTORY);
      if ( ord && OrderSymbol() == _Symbol 
      && OrderMagicNumber() == MagicF )
         {
         if ( OrderProfit() < 0 )
            {
            return OrderLots() * MathAbs(LotMultiplierE);
            }
         else
            {
            return BasicLot;
            }
         }
      }
   return BasicLot;
   }
 ///

//////////////////////////////////////интерфейс

////функции для создания прямоугольника, текста, кнопки***********************
//создание прямоугольной рамки
bool RectLabelCreate(
const long chart_ID=0, // ID графика 
const string name="RectLabel", // имя метки 
const int sub_window=0, // номер подокна 
const int x=0, // координата по оси X 
const int y=0, // координата по оси Y 
const int width=50, // ширина 
const int height=18, // высота 
const color back_clr=C'236,233,216', // цвет фона 
const ENUM_BORDER_TYPE border=BORDER_SUNKEN, // тип границы const 
ENUM_BASE_CORNER corner=CORNER_LEFT_UPPER, // угол графика для привязки 
const color clr=clrRed, // цвет плоской границы (Flat) 
const ENUM_LINE_STYLE style=STYLE_SOLID, // стиль плоской границы 
const int line_width=1, // толщина плоской границы 
const bool back=false, // на заднем плане const 
bool selection=false, // выделить для перемещений 
const bool hidden=true, // скрыт в списке объектов 
const long z_order=0) // приоритет на нажатие мышью 
{ 
//--- сбросим значение ошибки 
ResetLastError(); 
//--- создадим прямоугольную метку 
if(!ObjectCreate(chart_ID,name,OBJ_RECTANGLE_LABEL,sub_window,0,0)) 
   { 
   Print(__FUNCTION__, ": не удалось создать прямоугольную метку! Код ошибки = ",GetLastError()); 
   return(false); 
   } 
//--- установим координаты метки 
ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x); 
ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y); 
//--- установим размеры метки 
ObjectSetInteger(chart_ID,name,OBJPROP_XSIZE,width); 
ObjectSetInteger(chart_ID,name,OBJPROP_YSIZE,height); 
//--- установим цвет фона 
ObjectSetInteger(chart_ID,name,OBJPROP_BGCOLOR,back_clr); 
//--- установим тип границы 
ObjectSetInteger(chart_ID,name,OBJPROP_BORDER_TYPE,border); 
//--- установим угол графика, относительно которого будут определяться координаты точки 
ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner); 
//--- установим цвет плоской рамки (в режиме Flat) 
ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr); 
//--- установим стиль линии плоской рамки 
ObjectSetInteger(chart_ID,name,OBJPROP_STYLE,style); 
//--- установим толщину плоской границы 
ObjectSetInteger(chart_ID,name,OBJPROP_WIDTH,line_width); 
//--- отобразим на переднем (false) или заднем (true) плане 
ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back); 
//--- включим (true) или отключим (false) режим перемещения метки мышью 
ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection); 
ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection); 
//--- скроем (true) или отобразим (false) имя графического объекта в списке объектов 
ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden); 
//--- установим приоритет на получение события нажатия мыши на графике 
ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order); 
//--- успешное выполнение 
return(true); 
}

//создание текста
bool LabelCreate(const long              chart_ID=0,               // ID графика
                 const string            name="Label",             // имя метки
                 const int               sub_window=0,             // номер подокна
                 const int               x=0,                      // координата по оси X
                 const int               y=0,                      // координата по оси Y
                 const ENUM_BASE_CORNER  corner=CORNER_LEFT_UPPER, // угол графика для привязки
                 const string            text="Label",             // текст
                 const string            font="Arial",             // шрифт
                 const int               font_size=10,             // размер шрифта
                 const color             clr=clrRed,               // цвет
                 const double            angle=0.0,                // наклон текста
                 const ENUM_ANCHOR_POINT anchor=ANCHOR_LEFT_UPPER, // способ привязки
                 const bool              back=false,               // на заднем плане
                 const bool              selection=false,          // выделить для перемещений
                 const bool              hidden=true,              // скрыт в списке объектов
                 const long              z_order=0)                // приоритет на нажатие мышью
  {
//--- сбросим значение ошибки
   ResetLastError();
//--- создадим текстовую метку
   if(!ObjectCreate(chart_ID,name,OBJ_LABEL,sub_window,0,0))
     {
      Print(__FUNCTION__,
            ": не удалось создать текстовую метку! Код ошибки = ",GetLastError());
      return(false);
     }
//--- установим координаты метки
   ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y);
//--- установим угол графика, относительно которого будут определяться координаты точки
   ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner);
//--- установим текст
   ObjectSetString(chart_ID,name,OBJPROP_TEXT,text);
//--- установим шрифт текста
   ObjectSetString(chart_ID,name,OBJPROP_FONT,font);
//--- установим размер шрифта
   ObjectSetInteger(chart_ID,name,OBJPROP_FONTSIZE,font_size);
//--- установим угол наклона текста
   ObjectSetDouble(chart_ID,name,OBJPROP_ANGLE,angle);
//--- установим способ привязки
   ObjectSetInteger(chart_ID,name,OBJPROP_ANCHOR,anchor);
//--- установим цвет
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
//--- отобразим на переднем (false) или заднем (true) плане
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
//--- включим (true) или отключим (false) режим перемещения метки мышью
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
//--- скроем (true) или отобразим (false) имя графического объекта в списке объектов
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
//--- установим приоритет на получение события нажатия мыши на графике
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
//--- успешное выполнение
   return(true);
  }

//создание кнопки
bool ButtonCreate(
const long chart_ID=0,
// ID графика 
const string name="Button", 
// имя кнопки 
const int sub_window=0, 
// номер подокна 
const int x=0, 
// координата по оси X 
const int y=0, 
// координата по оси Y 
const int width=50, 
// ширина кнопки 
const int height=18, 
// высота кнопки 
const ENUM_BASE_CORNER corner=CORNER_LEFT_UPPER, 
// угол графика для привязки 
const string text="Button", 
// текст 
const string font="Arial", 
// шрифт 
const int font_size=10, 
// размер шрифта 
const color clr=clrBlack, 
// цвет текста 
const color back_clr=C'236,233,216', 
// цвет фона 
const color border_clr=clrNONE, 
// цвет границы 
const bool state=false, 
// нажата/отжата 
const bool back=false, 
// на заднем плане 
const bool selection=false, 
// выделить для перемещений 
const bool hidden=true, 
// скрыт в списке объектов 
const long z_order=0) // приоритет на нажатие мышью 
{ 
//--- сбросим значение ошибки 
ResetLastError(); 
//--- создадим кнопку 
if(!ObjectCreate(chart_ID,name,OBJ_BUTTON,sub_window,0,0)) 
   { 
   Print(__FUNCTION__, ": не удалось создать кнопку! Код ошибки = ",GetLastError()); 
   return(false); 
   } 
//--- установим координаты кнопки 
ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x); 
ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y); 
//--- установим размер кнопки 
ObjectSetInteger(chart_ID,name,OBJPROP_XSIZE,width); 
ObjectSetInteger(chart_ID,name,OBJPROP_YSIZE,height); 
//--- установим угол графика, относительно которого будут определяться координаты точки 
ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner); 
//--- установим текст 
ObjectSetString(chart_ID,name,OBJPROP_TEXT,text); 
//--- установим шрифт текста 
ObjectSetString(chart_ID,name,OBJPROP_FONT,font); 
//--- установим размер шрифта 
ObjectSetInteger(chart_ID,name,OBJPROP_FONTSIZE,font_size); 
//--- установим цвет текста 
ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr); 
//--- установим цвет фона 
ObjectSetInteger(chart_ID,name,OBJPROP_BGCOLOR,back_clr); 
//--- установим цвет границы 
ObjectSetInteger(chart_ID,name,OBJPROP_BORDER_COLOR,border_clr); 
//--- отобразим на переднем (false) или заднем (true) плане 
ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back); 
//--- переведем кнопку в заданное состояние 
ObjectSetInteger(chart_ID,name,OBJPROP_STATE,state); 
//--- включим (true) или отключим (false) режим перемещения кнопки мышью 
ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection); 
ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection); 
//--- скроем (true) или отобразим (false) имя графического объекта в списке объектов 
ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden); 
//--- установим приоритет на получение события нажатия мыши на графике 
ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order); 
//--- успешное выполнение 
return(true); 
}
////конец описания функций для создания прямоугольника, текста, кнопки*********************** 
 
 
////создание интерфейса, обновление интерфейса

//имена будущих объектов интерфейса
string OwnObjectNames[] = {
"BorderPanel",//RectLabel
"MainPanel",//RectLabel
"Name",//Label
"Balance",//Label
"Equity",//Label
"Profit",//Label
"Broker",//Label
"Leverage",//Label
"Spread",//Label
"BuyPositions",//Label
"SellPositions",//Label
"CurrentUnitsBuy",//Label
"CurrentUnitsSell",//Label
"DaysRemaining",//Label
"StartDate",//Label
"EndDate",//Label
"CloseOwn",//Button
"CloseAll",//Button
"Line-Divider1",//RectLabel разделитель 1
"Line-Divider2",//RectLabel разделитель 2
"Line-Divider3",//RectLabel разделитель 3
"Line-Divider4"//RectLabel разделитель 4
};

void UpdateStatus()//обновление состояния интерфейса
   {
   string TempText="Balance : ";
   TempText+=DoubleToStr(NormalizeDouble(AccountBalance(),2),2);
   ObjectSetString(0,OwnObjectNames[3],OBJPROP_TEXT,TempText);
   TempText="Equity : ";
   TempText+=DoubleToStr(NormalizeDouble(AccountEquity(),2),2);
   ObjectSetString(0,OwnObjectNames[4],OBJPROP_TEXT,TempText);
   TempText="Leverage : 1/";
   TempText+=DoubleToStr(AccountLeverage(),0);
   ObjectSetString(0,OwnObjectNames[7],OBJPROP_TEXT,TempText);
   TempText="Broker : ";
   TempText+=AccountCompany();
   ObjectSetString(0,OwnObjectNames[6],OBJPROP_TEXT,TempText);
   TempText="Spread : ";
   MqlTick LastTick;
   SymbolInfoTick(_Symbol,LastTick);
   TempText+=DoubleToStr((LastTick.ask-LastTick.bid)/_Point,0);
   ObjectSetString(0,OwnObjectNames[8],OBJPROP_TEXT,TempText);
   ///////////////////////////
   TempText="Buy positions : ";
   TempText+=DoubleToStr(NormalizeDouble(CalculateBuyQuantity(),0),0);   
   ObjectSetString(0,OwnObjectNames[9],OBJPROP_TEXT,TempText);
   TempText="Sell positions : ";
   TempText+=DoubleToStr(NormalizeDouble(CalculateSellQuantity(),0),0);      
   ObjectSetString(0,OwnObjectNames[10],OBJPROP_TEXT,TempText);
   TempText="Buy lots : ";
   TempText+=DoubleToStr(NormalizeDouble(CalculateBuyLots(),3),3);   
   ObjectSetString(0,OwnObjectNames[11],OBJPROP_TEXT,TempText);
   TempText="Sell lots : ";
   TempText+=DoubleToStr(NormalizeDouble(CalculateSellLots(),3),3);   
   ObjectSetString(0,OwnObjectNames[12],OBJPROP_TEXT,TempText);
   TempText="Profit : ";
   TempText+=DoubleToStr(NormalizeDouble(AccountEquity()-AccountBalance(),2),2);
   ObjectSetString(0,OwnObjectNames[5],OBJPROP_TEXT,TempText);
   ////////////////////////////
   TempText="Days remaining : ";
   if ( double(DaysToFuture)-Days() > 0 ) TempText+=DoubleToString(NormalizeDouble(double(DaysToFuture)-Days(),2),2);
   else TempText+="0, trading disabled!";
   ObjectSetString(0,OwnObjectNames[13],OBJPROP_TEXT,TempText);
   TempText="Optimization finished : ";
   MqlDateTime StartDate;
   TimeToStruct(DatetimeStart,StartDate);
   TempText+=IntegerToString(StartDate.day)+"."+IntegerToString(StartDate.mon)+"."+IntegerToString(StartDate.year);
   ObjectSetString(0,OwnObjectNames[14],OBJPROP_TEXT,TempText);
   TempText="Will trade until : ";
   MqlDateTime EndDate;
   TimeToStruct(DatetimeStart+datetime(DaysToFuture*86400),EndDate);
   TempText+=IntegerToString(EndDate.day)+"."+IntegerToString(EndDate.mon)+"."+IntegerToString(EndDate.year);
   ObjectSetString(0,OwnObjectNames[15],OBJPROP_TEXT,TempText);
   ///////////////////////////
         
   }

double CalculateBuyLots()//посчитать свои лоты на покупку
   {
   double Lots=0;
   bool ord;
   for ( int i=0; i<OrdersTotal(); i++ )
      {
      ord=OrderSelect( i, SELECT_BY_POS, MODE_TRADES );
      if ( ord && OrderSymbol() == Symbol() &&  OrderMagicNumber() == MagicF && OrderType() == OP_BUY )
         {
         Lots+=OrderLots();
         }
      }
   return Lots;   
   }
   
double CalculateSellLots()//посчитать свои лоты на продажу
   {
   double Lots=0;
   bool ord;
   for ( int i=0; i<OrdersTotal(); i++ )
      {
      ord=OrderSelect( i, SELECT_BY_POS, MODE_TRADES );
      if ( ord && OrderSymbol() == Symbol() &&  OrderMagicNumber() == MagicF && OrderType() == OP_SELL )
         {
         Lots+=OrderLots();
         }
      }
   return Lots;
   }
   
double CalculateBuyQuantity()//посчитать количество входов на покупку
   {
   double Positions=0;
   bool ord;
   for ( int i=0; i<OrdersTotal(); i++ )
      {
      ord=OrderSelect( i, SELECT_BY_POS, MODE_TRADES );
      if ( ord && OrderSymbol() == Symbol() &&  OrderMagicNumber() == MagicF && OrderType() == OP_BUY )
         {
         Positions++;
         }
      }
   return Positions;   
   }
   
double CalculateSellQuantity()//посчитать количество входов на продажу
   {
   double Positions=0;
   bool ord;
   for ( int i=0; i<OrdersTotal(); i++ )
      {
      ord=OrderSelect( i, SELECT_BY_POS, MODE_TRADES );
      if ( ord && OrderSymbol() == Symbol() &&  OrderMagicNumber() == MagicF && OrderType() == OP_SELL )
         {
         Positions++;
         }
      }
   return Positions;
   }        

void CloseAllI(int magic0)//закрыть все
   {
   bool order;
   bool ord;
   int Tickets[];
   double Lotsx[];
   bool Typex[];      
   string SymbolX[];   
   int TicketsTotal=0;
   int TicketNumCurrent=0;
   MqlTick TickS;
   
   for ( int i=0; i<OrdersTotal(); i++ )
      {
      ord=OrderSelect( i, SELECT_BY_POS, MODE_TRADES );
                         
      if ( ord && ( OrderMagicNumber() == magic0 || magic0 == -1 ) )
         {
         TicketsTotal=TicketsTotal+1;
         }
      }
   ArrayResize(Tickets,TicketsTotal);
   ArrayResize(Lotsx,TicketsTotal);
   ArrayResize(Typex,TicketsTotal);
   ArrayResize(SymbolX,TicketsTotal);
         
   for ( int i=0; i<OrdersTotal(); i++ )
      {
      ord=OrderSelect( i, SELECT_BY_POS, MODE_TRADES );
                         
      if ( ord && ( OrderMagicNumber() == magic0 || magic0 == -1 ) && TicketNumCurrent < TicketsTotal )
         {
         Tickets[TicketNumCurrent]=OrderTicket();
         if ( OrderType() == OP_BUY )
            {
            Typex[TicketNumCurrent]=true;
            }
         if ( OrderType() == OP_SELL )
            {
            Typex[TicketNumCurrent]=false;
            }                           
         Lotsx[TicketNumCurrent]=OrderLots();
         SymbolX[TicketNumCurrent]=OrderSymbol();            
         TicketNumCurrent=TicketNumCurrent+1;
         }
      }
      
   for ( int i=0; i<TicketsTotal; i++ )
      {
      SymbolInfoTick(SymbolX[i],TickS);
      if ( Typex[i] == true )
         {
         order=OrderClose(Tickets[i],Lotsx[i],TickS.bid,100,Green);
         }
      if ( Typex[i] == false )
         {
         order=OrderClose(Tickets[i],Lotsx[i],TickS.ask,100,Red);
         }       
      }                     
   }

void CreateSimpleInterface()//создаем простейший интерфейс
   {
   ENUM_BASE_CORNER corner=CORNER_LEFT_UPPER;//привязка всех элементов в верхний левый угол
   int x=5;//смещение по "x";
   int y=15;//смещение по "y";
   int Width = 280;//ширина
   int Height = 330;//высота
   int Border = 5;//граница
   
   RectLabelCreate(0,OwnObjectNames[0],0,x,y,Width+2*Border,Height+2*Border,clrRed,BORDER_RAISED,corner,clrOrchid,STYLE_SOLID,3,false,false,true,0);//рамка
   RectLabelCreate(0,OwnObjectNames[1],0,x+Border,y+Border,Width,Height,clrCornflowerBlue,BORDER_RAISED,corner,clrOrchid,STYLE_SOLID,3,false,false,true,0);//основная панель
   //текстовые элементы
   LabelCreate(0,OwnObjectNames[2],0,x+Border+32,y+Border,corner,"AWAITER AUTO GENERATION BOT","Agency FB",17,clrSnow,0.0);//имя советника
   //
   RectLabelCreate(0,OwnObjectNames[18],0,x+Border,y+Border+25,Width,5,clrSnow,BORDER_RAISED,corner,clrOrchid,STYLE_SOLID,0,false,false,true,0);//первый разделитель   
   //текстовые элементы
   LabelCreate(0,OwnObjectNames[3],0,x+Border+2,y+17+Border+20*1,corner,"Balance : ","Arial",11,clrSnow,0.0,ANCHOR_LEFT);//баланс
   LabelCreate(0,OwnObjectNames[4],0,x+Border+2,y+17+Border+20*2,corner,"Equity : ","Arial",11,clrSnow,0.0,ANCHOR_LEFT);//эквити
   LabelCreate(0,OwnObjectNames[7],0,x+Border+2,y+17+Border+20*3,corner,"Leverage : ","Arial",11,clrSnow,0.0,ANCHOR_LEFT);//плечо
   LabelCreate(0,OwnObjectNames[6],0,x+Border+2,y+17+Border+20*4,corner,"Broker : ","Arial",11,clrSnow,0.0,ANCHOR_LEFT);//брокер
   LabelCreate(0,OwnObjectNames[8],0,x+Border+2,y+17+Border+20*5,corner,"Spread : ","Arial",11,clrSnow,0.0,ANCHOR_LEFT);//спред           
   //
   RectLabelCreate(0,OwnObjectNames[19],0,x+Border,y+Border+25+100,Width,5,clrSnow,BORDER_RAISED,corner,clrOrchid,STYLE_SOLID,0,false,false,true,0);//второй разделитель   
   //текстовые элементы
   LabelCreate(0,OwnObjectNames[9],0,x+Border+2,y+17+Border+20*5+20,corner,"Buy positions : ","Arial",11,clrSnow,0.0,ANCHOR_LEFT);//позиции на покупку
   LabelCreate(0,OwnObjectNames[10],0,x+Border+2,y+17+Border+20*5+20*2,corner,"Sell positions : ","Arial",11,clrSnow,0.0,ANCHOR_LEFT);//позиции на продажу
   LabelCreate(0,OwnObjectNames[11],0,x+Border+2,y+17+Border+20*5+20*3,corner,"Buy lots : ","Arial",11,clrSnow,0.0,ANCHOR_LEFT);//объем позиций на покупку
   LabelCreate(0,OwnObjectNames[12],0,x+Border+2,y+17+Border+20*5+20*4,corner,"Sell lots : ","Arial",11,clrSnow,0.0,ANCHOR_LEFT);//объем позиций на продажу
   LabelCreate(0,OwnObjectNames[5],0,x+Border+2,y+17+Border+20*5+20*5,corner,"Profit : ","Arial",11,clrSnow,0.0,ANCHOR_LEFT);//прибыль висящих позиций       
   //
   RectLabelCreate(0,OwnObjectNames[20],0,x+Border,y+Border+25+100+100,Width,5,clrSnow,BORDER_RAISED,corner,clrOrchid,STYLE_SOLID,0,false,false,true,0);//третий разделитель
   //текстовые элементы
   LabelCreate(0,OwnObjectNames[13],0,x+Border+2,y+17+Border+20*5+20*5+23,corner,"Days remaining : ","Arial",11,clrSnow,0.0,ANCHOR_LEFT);//сколько дней осталось торговать
   LabelCreate(0,OwnObjectNames[14],0,x+Border+2,y+17+Border+20*5+20*5+23+20*1,corner,"Optimization finished : ","Arial",11,clrSnow,0.0,ANCHOR_LEFT);//дата конца оптимизации
   LabelCreate(0,OwnObjectNames[15],0,x+Border+2,y+17+Border+20*5+20*5+23+20*2,corner,"Will trade until : ","Arial",11,clrSnow,0.0,ANCHOR_LEFT);//дата до которой торгуем
   //   
   RectLabelCreate(0,OwnObjectNames[21],0,x+Border,y+Border+25+100+95+72,Width,5,clrSnow,BORDER_RAISED,corner,clrOrchid,STYLE_SOLID,0,false,false,true,0);//четвертый разделитель
   ButtonCreate(0,OwnObjectNames[16],0,x+Border+5,y+17+Border+20*5+20*5+23+20*2+20,130,25,corner,"Close own orders","Arial",11,clrSnow,clrCrimson,clrNONE,false,false,false,true,0);
   ButtonCreate(0,OwnObjectNames[17],0,x+Border+5+140,y+17+Border+20*5+20*5+23+20*2+20,130,25,corner,"Close all orders","Arial",11,clrSnow,clrBlueViolet,clrNONE,false,false,false,true,0);
   }

 
void ButtonsCheck(string sparam0)//проверка кнопок отжатие и закрытие соответствующих ордеров
   {
   if ( sparam0 == OwnObjectNames[16] )//close own
      {
      CloseAllI(MagicF);
      }
      
   if ( sparam0 == OwnObjectNames[17] )//close all
      {
      CloseAllI(-1);
      }         
   
   if ( sparam0 == OwnObjectNames[16] || sparam0 == OwnObjectNames[17] )
      {
      if ( ObjectGetInteger(0,sparam0,OBJPROP_STATE,0) )
         {
         ObjectSetInteger(0,OwnObjectNames[16],OBJPROP_STATE,false);
         ObjectSetInteger(0,OwnObjectNames[17],OBJPROP_STATE,false);
         }      
      }
   } 
 
void DeleteSimpleInterface()//удалить все элементы интерфейса
   {
   int NumObj=1;

   while ( NumObj > 0 )
      {    
      for(int i=0;i<ObjectsTotal();i++)
         {     
         for(int j=0;j<ArraySize(OwnObjectNames);j++)
            {
            if ( ObjectName(i) == OwnObjectNames[j] ) ObjectDelete(ObjectName(i));
            }
         }
      NumObj=0;   
      for(int i=0;i<ObjectsTotal();i++)
         {         
         for(int j=0;j<ArraySize(OwnObjectNames);j++)
            {
            if ( ObjectName(i) == OwnObjectNames[j] ) NumObj++;
            }     
         }         
      } 
   }

void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
  if (id == CHARTEVENT_OBJECT_CLICK )//
     {
     ButtonsCheck(sparam);
     }
  } 

//////////////////////////////////////
